



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>android 7.0+ FileProvider 访问隐私文件 相册、相机、安装应用的适配</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">android 7.0+ FileProvider 访问隐私文件 相册、相机、安装应用的适配</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 13:12:26 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>从 Android 7.0 开始，Android SDK 中的&nbsp;<a href="https://developer.android.com/reference/android/os/StrictMode.html" rel="external nofollow noreferrer">StrictMode</a>&nbsp;策略禁止开发人员在应用外部公开&nbsp;file://&nbsp;URI。具体表现为，当我们在应用中使用包含&nbsp;file://&nbsp;URI 的 Intent 离开自己的应用时，程序会发生FileUriExposedException&nbsp;异常</p>
<p>这里我们要使用到的&nbsp;<code>FileProvider</code>，就是&nbsp;<code>ContentProvider</code>&nbsp;的一个特殊子类，帮助我们将访问受限的&nbsp;file://&nbsp;URI 转化为可以授权共享的&nbsp;content://&nbsp;URI。</p>
<p>首先 要去 Manifest文件里注册FileProvider</p>
<div>
<pre class="prettyprint linenums"> &lt;application<br />
        android:allowBackup="true"<br />
        android:icon="@mipmap/ic_launcher"<br />
        android:label="@string/app_name"<br />
        android:supportsRtl="true"<br />
        android:theme="@style/AppTheme"&gt;<br />
        &lt;activity android:name=".MainActivity"&gt;<br />
            &lt;intent-filter&gt;<br />
                &lt;action android:name="android.intent.action.MAIN" /&gt;

                &lt;category android:name="android.intent.category.LAUNCHER" /&gt;<br />
            &lt;/intent-filter&gt;<br />
        &lt;/activity&gt;

        &lt;provider<br />
            android:name="android.support.v4.content.FileProvider"<br />
            android:authorities="${applicationId}.FileProvider" //此处的属性值后面获取URI用到<br />
            android:grantUriPermissions="true"<br />
            android:exported="false"&gt;<br />
            &lt;meta-data<br />
                android:name="android.support.FILE_PROVIDER_PATHS"<br />
                android:resource="@xml/file_paths"/&gt;<br />
        &lt;/provider&gt;<br />
    &lt;/application&gt;</pre>
</div>
<p>其次在&nbsp;res 目录下新建一个 xml 文件夹 里边添加一个xml文件 名字比如：path.xml</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="utf-8"?&gt;<br />
&lt;paths xmlns:android="http://schemas.android.com/apk/res/android"&gt;<br />
    &lt;external-path name="my_images" path="."/&gt; &lt;!-- 此处的name可以随便取--!&gt;

&lt;/paths&gt;</pre>
</div>
<p>元素必须包含一到多个子元素。这些子元素用于指定共享文件的目录路径，必须是这些元素之一：</p>
<p>&lt;files-path&gt;：内部存储空间应用私有目录下的 files/ 目录，等同于 Context.getFilesDir() 所获取的目录路径；</p>
<p>&lt;cache-path&gt;：内部存储空间应用私有目录下的 cache/ 目录，等同于 Context.getCacheDir() 所获取的目录路径；</p>
<p>&lt;external-path&gt;：外部存储空间根目录，等同于 Environment.getExternalStorageDirectory() 所获取的目录路径；</p>
<p>&lt;external-files-path&gt;：外部存储空间应用私有目录下的 files/ 目录，等同于 Context.getExternalFilesDir(null) 所获取的目录路径；</p>
<p>&lt;external-cache-path&gt;：外部存储空间应用私有目录下的 cache/ 目录，等同于 Context.getExternalCacheDir()；</p>
<p>获取URI的方法：</p>
<p><strong>&nbsp;在Android7.0以下 获取相册图片URI的方式：</strong></p>
<div>
<pre class="prettyprint linenums">Uri uri= Uri.from ( file );</pre>
</div>
<p><strong>&nbsp;Android 7.0+获取相册图片的方式：</strong></p>
<div>
<pre class="prettyprint linenums">   //注意此处的 第二个参数必须与 Manifest文件中Provider 的 android:authorities 一致</pre>
<pre class="prettyprint linenums">Uri contentUri = FileProvider.getUriForFile(this, BuildConfig.APPLICATION_ID + ".FileProvider", outputFile);</pre>
</div>
<p><strong>Android 7.0以下 安装应用：</strong></p>
<div>
<pre class="prettyprint linenums">Intent installIntent = new Intent(Intent.ACTION_VIEW);<br />
installIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);<br />
installIntent.setDataAndType(Uri.fromFile(apkFile), "application/vnd.android.package-archive");<br />
startActivity(installIntent);</pre>
</div>
<p><strong>Android 7.0+ 安装应用：</strong></p>
<div>
<p>//采用FileProvider的方式访问文件</p>
<p>File apkFile = new File(getExternalFilesDir(Environment.DIRECTORY_DOWNLOADS), "app_sample.apk");<br />Uri apkUri = FileProvider.getUriForFile(this,<br />        BuildConfig.APPLICATION_ID+".FileProvider", apkFile);</p>
<pre class="prettyprint linenums">Intent installIntent = new Intent(Intent.ACTION_VIEW);<br />
installIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);<br />//添加此处 是临时对文件的授权 必须加上此句<br />
installIntent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION);<br />
installIntent.setDataAndType(apkUri, "application/vnd.android.package-archive");<br />
startActivity(installIntent);</pre>
</div>
<p><strong>调用相机的时候：</strong></p>
<div>
<pre class="prettyprint linenums"> public void camera() {<br />
            Intent intent = new Intent("android.media.action.IMAGE_CAPTURE");<br />
            tempFile = new File(Environment.getExternalStorageDirectory(),PHOTO_FILE_NAME);<br />
            Uri uri;<br />
            if (Build.VERSION.SDK_INT &gt;= Build.VERSION_CODES.N) {<br />
                uri = FileProvider.getUriForFile(this, "com.camera.fileprovider",tempFile);<br />                   //此处为Uri临时授权<br />
                intent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION);<br />
            } else {<br />
                uri = Uri.fromFile(tempFile);<br />
            }<br />
            intent.putExtra(MediaStore.EXTRA_OUTPUT, uri);<br />
            startActivityForResult(intent, PHOTO_REQUEST_CAMERA);<br />
        }</pre>
</div>
<p><strong>裁剪图片：</strong></p>
<div>
<pre class="prettyprint linenums">public static void cropImageUri(Activity activity, Uri orgUri, Uri desUri, int aspectX, int aspectY, int width, int height, int requestCode) {<br />
    Intent intent = new Intent("com.android.camera.action.CROP");<br />
    if (Build.VERSION.SDK_INT &gt;= Build.VERSION_CODES.N) {<br />          //此处为Uri临时授权<br />
        intent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION);<br />
    }<br />
    intent.setDataAndType(orgUri, "image/*"); //此处的Uri为 输入Uri用FileProvider的方式获取<br />
    intent.putExtra("crop", "true");<br />
    intent.putExtra("aspectX", aspectX);<br />
    intent.putExtra("aspectY", aspectY);<br />
    intent.putExtra("outputX", width);<br />
    intent.putExtra("outputY", height);<br />
    intent.putExtra("scale", true);<br />
    //将剪切的图片保存到目标Uri中<br />
    intent.putExtra(MediaStore.EXTRA_OUTPUT, desUri);//此处的Uri为输出Uri 需要用Uri.fromFile()的方式获取<br />
    intent.putExtra("return-data", false);<br />
    intent.putExtra("outputFormat", Bitmap.CompressFormat.JPEG.toString());<br />
    intent.putExtra("noFaceDetection", true);<br />
    activity.startActivityForResult(intent, requestCode);<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwo5or9.html">width的数值为百分比</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mw2l2q.html">电量&sol;信号的显示 imageLevel</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mn3mxq.html">JavaScript引用类型&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd0r2r8.html">DFS入门之一</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj4rny9.html">杂记之web篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pmzjy8.html">MySQL的索引创建、删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mdl7o8.html">Java中的设计模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk5w5d8.html">mybatis面向接口的编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mewjzpq.html">关于v-model、v-for、v-on的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp4r1j9.html">Struts 2 标签库及使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1306jq.html">git 同步勾子</a>
		</li>
						<li><a href="https://www.batexi.com/a/9501o208.html">Android开发学习之路--Activity之Intent</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj6yelq.html">Java进阶篇设计模式之五-----外观模式和装饰器模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r7g2n9.html">【webpack学习笔记】a03-管理输出</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdxpde9.html">MT【41】利用不等式妙消参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjl4e79.html">linux安装dpkg安装缺少依赖项的解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp1vkl9.html">C&num; 导入（读取） WPS ET文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/902vedmq.html">MongoDB 聚合嵌入的数组（扁平化数据&plus;管道）</a>
		</li>
						<li><a href="https://www.batexi.com/a/953m6nm8.html">&lbrack;&period;NET开发&rsqb; NPOI导出</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o45rxeq.html">VisualSVN安装配置与使用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/960o1dj9.html">一个小白用 PhotoView 引起的学习记录</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gx64zq.html">pip install pytest on Mac &lpar;EI Capitan 10&period;11&period;6&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlljevkq.html">CentOS 7 升级 Linux 内核</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlljmz6q.html">域名动态解析到动态IP</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rkr658.html">Oracle所有分析函数&amp;lt&semi;转&amp;gt&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/960p0e39.html">Linux 如何使用gdb 查看core堆栈信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jzpvnq.html">嵌入式linux&mdash;&mdash;汇编、C语言基础（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvjdpg8.html">深度学习原理与框架-  tf&period;nn&period;atrous&lowbar;conv2d&lpar;空洞卷积&rpar; 问题：空洞卷积增加了卷积核的维度，为什么不直接使用7&ast;7呢</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyor439.html">springboot security</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllj5l0q.html">3&period;Telnet探测端口后怎么退出</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
